#include <linux/ps2/ee.h>
#include <ps2dma.h>
#include <ps2vpu.h>
#include <stdio.h>
#include <unistd.h>
#include <libvu0.h>
#include <ps2vpufile.h>
#include <sys/mman.h>
#include <errno.h>

IMPORT_VPU_SYMBOL(__u128 *, My_dma_start, 0)

int main() {

        ps2_vpu *vdev0, *vdev1;
        VPUFILE *vfd1;

	float *q;
	int i=0;
	int result;

	/* Prepare access to VU0 */
        vdev0 = ps2_vpu_open(0);
        ps2_vpu_reset(vdev0);
        vdev1 = ps2_vpu_open(1);
        ps2_vpu_reset(vdev1);

	/* Retrieve mmaped shared mem of VU Mem0 */
	q = ps2_vpu_data(vdev1);	

	/* Prepare our vector addition code to be sent to VU0 */
        vfd1 = vpuobj_open("execute.elf", O_DATA_PS2MEM);
        if (vfd1 < 0) {
                perror("vpu_open");
                exit(1);
        }
	
	/* Actually send the code to VU0 */
	ps2_dma_send(ps2_vpu_fd(vdev1), vfd1, (ps2_dmatag *)My_dma_start); 
	
	/* Fire up VU0 */
	ps2_vpu_start(vdev1,0);
	while ( ps2_vpu_busy(vdev1)) { i++; } 
	fprintf(stderr, "[float registers]\n");
	fprintf(stderr, "VF00: x: %f y: %f z: %f w: %f [constant]\n", q[100], q[101], q[102], q[103]); 
	fprintf(stderr, "VF01: x: %f y: %f z: %f w: %f \n", q[104], q[105], q[106], q[107]); 
	fprintf(stderr, "VF02: x: %f y: %f z: %f w: %f \n", q[108], q[109], q[110], q[111]); 
	fprintf(stderr, "VF03: x: %f y: %f z: %f w: %f \n", q[112], q[113], q[114], q[115]); 
	fprintf(stderr, "VF04: x: %f y: %f z: %f w: %f \n", q[116], q[117], q[118], q[119]); 
	fprintf(stderr, "\n[integer registers]\n");
	fprintf(stderr, "VI00: %0.f\t\t[constant]\nVI01: %0.f\nVI02: %0.f\nVI03: %0.f\n", q[132], q[133], q[134], q[135]);
	fprintf(stderr, "VI04: %0.f\nVI05: %0.f\nVI06: %0.f\nVI07: %0.f\n", q[136], q[137], q[138], q[139]); 
	
        ps2_vpu_close(vdev1);
        ps2_vpu_close(vdev0);

}
